#ifndef _lucene_Config_
#define _lucene_Config_

//define this if multi-threading support is not required
//if not defined, multi-thread locking will 
//occur (and its related processing overhead)
//#define LUCENE_DISABLE_MULTITHREADING

//define this if Unicode support is desired
//(This is usually already defined in the compile parameters)
//#define _UNICODE

//define this if read only access
//saves on compiling all the writing code
//#define CLUCENE_LITE


//if defined, indexing information will be sent 
//to the IndexWriter->infoStream stream
//#define USE_INFO_STREAM

/////////////////////////
//The following are defines that can make CLucene faster and/or smaller
//special queries sometime require longer search times or may not be necessary
//
//Define this to remove fuzzy query and sloppy scoring
//#define NO_FUZZY_QUERY
//
//Define to remove wildcard t*m or te?m to match term
//#define NO_WILDCARD_QUERY
//
//Define to remove prefix term query - ter* to match term or terms
//#define NO_PREFIX_QUERY
//
//Define to remove range (exlusive and inclusive)
//#define NO_RANGE_QUERY
/////////////////////////


//some defaults, wouldn't usually need to be changed
//Buffer size for input, output and stringbuffer streams
#define LUCENE_STREAM_BUFFER_SIZE 1024

//Number of documents IndexWriter keeps before writing to disk.
#define LUCENE_WRITER_INDEX_INTERVAL 128

//Size of TermScore cache
#define LUCENE_SCORE_CACHE_SIZE 32

//Maximum length of a token word
//if not defined, then no limit, but may affect performance
//#define LUCENE_TOKEN_WORD_LENGTH 255

#endif
